#include "StdAfx.h"
#include ".\controller.h"
#include "resource.h"

CController::CController(void)
: _edit			(NULL, IDC_EDIT)
, _tree			(NULL, IDC_TREE)
, _slider		(NULL, IDC_SLIDER)
, _editEndpoint	(NULL, IDC_EDIT_ENDPOINT)
, _editService	(NULL, IDC_EDIT_SERVICE)
, _editMethod	(NULL, IDC_EDIT_METHOD)
, _editModus	(NULL, IDC_EDIT_MODUS)
, _editLogging	(NULL, IDC_EDIT_LOGGING)
{
	this->m_szFileText = (char*)malloc(16777215 * sizeof(char));
	this->m_szResultText = (char*)malloc(16777215 * sizeof(char));
	_editEndpoint.SetString("Endpoint to send the http POST...");
	_editService.SetString("The service");
	_editMethod.SetString("The method");
	_editModus.SetString("The Mode");
}

CController::CController(HWND hwnd)
: _edit			(hwnd, IDC_EDIT)
, _tree			(hwnd, IDC_TREE)
, _slider		(hwnd, IDC_SLIDER)
, _editEndpoint	(hwnd, IDC_EDIT_ENDPOINT)
, _editService	(hwnd, IDC_EDIT_SERVICE)
, _editMethod	(hwnd, IDC_EDIT_METHOD)
, _editModus	(hwnd, IDC_EDIT_MODUS)
, _editLogging	(hwnd, IDC_EDIT_LOGGING)
{
	this->m_szFileText = (char*)malloc(16777215 * sizeof(char));
	this->m_szResultText = (char*)malloc(16777215 * sizeof(char));
	_slider.SetRange(100);
	_slider.SetPosition(50);
	_editEndpoint.SetString("Endpoint to send the http POST...");
	_editService.SetString("The service");
	_editMethod.SetString("The method");
	_editModus.SetString("The Mode");
}

CController::CController(HWND hwnd, HINSTANCE hInst)
: _edit			(hwnd, IDC_EDIT)
, _tree			(hwnd, IDC_TREE, hInst)
, _slider		(hwnd, IDC_SLIDER)
, _editEndpoint	(hwnd, IDC_EDIT_ENDPOINT)
, _editService	(hwnd, IDC_EDIT_SERVICE)
, _editMethod	(hwnd, IDC_EDIT_METHOD)
, _editModus	(hwnd, IDC_EDIT_MODUS)
, _editLogging	(hwnd, IDC_EDIT_LOGGING)
{
	this->m_szFileText = (char*)malloc(16777215 * sizeof(char));
	this->m_szResultText = (char*)malloc(16777215 * sizeof(char));
	_slider.SetRange(100);
	_slider.SetPosition(50);
	_editEndpoint.SetString("Endpoint to send the http POST...");
	_editService.SetString("The service");
	_editMethod.SetString("The method");
	_editModus.SetString("The Mode");
}

CController::~CController(void)
{
	free(this->m_szFileText);
}

void CController::Command (HWND hwnd, int controlID, int command)
{
    switch (controlID)
    {
        case IDC_EDIT:
            break;
		case IDC_TREE:
			break;
		case IDC_SLIDER:
			break;
		case IDC_BUTTON1:
			{
			OPENFILENAME ofn;
			char szFileName[MAX_PATH] = "";

			ZeroMemory(&ofn, sizeof(ofn));

			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hwnd;
			ofn.lpstrFilter = "SpaSe Files (*.xml, *.awql, *.awml)\0*.xml;*.awql;*.awml\0" 
							  "XML (*.xml)\0*.xml\0" 
							  "AWQL (*.awql)\0*.awql\0" 
							  "AWML (*.aqml)\0*.awml\0" 
							  "Alle Dateien (*.*)\0*.*\0";
			ofn.lpstrFile = szFileName;
			ofn.nMaxFile = MAX_PATH;
			ofn.lpstrDefExt = "xml";
			ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_ENABLESIZING;

			if(GetOpenFileName(&ofn))
			{
				char Out[MAX_LOADSTRING];
				strcpy(Out, szFileName);
				strcpy(this->m_szFileName, szFileName);
				strcat(Out, " -> \n\n");
				_edit.SetString(Out);
				HANDLE hFile;
				BOOL bSuccess = FALSE;

				hFile = CreateFile(szFileName, GENERIC_READ,
									FILE_SHARE_READ, NULL,
									OPEN_EXISTING, 0, NULL);
				if(hFile != INVALID_HANDLE_VALUE)
				{
					DWORD dwFileSize;

					dwFileSize = GetFileSize(hFile, NULL);
					if(dwFileSize != 0xFFFFFFFF)
					{
			            LPSTR pszFileText;

						pszFileText =(char *) GlobalAlloc(GPTR, dwFileSize + 1);
						if(pszFileText != NULL)
						{
							DWORD dwRead;
							if(ReadFile(hFile, pszFileText, dwFileSize, &dwRead, NULL))
							{
									pszFileText[dwFileSize] = '\0';
									bSuccess = TRUE;
							}
							_edit.SetString(pszFileText);
							strcpy(this->m_szFileText, pszFileText);
							GlobalFree(pszFileText);
						}
					}
					CloseHandle(hFile);
				}
			}
			break;
			}
		case IDC_BUTTON2:
			{
				// Init local vars
				char stringEndPoint[512] = "";
				char stringService[512] = "";
				char stringMethod[512] = "";
				char stringMode[5] = "";

				// The request object
				CSOAPClient* SpaSeClient;

				// Clear the Tree-View
				this->_tree.Reset();

				// Check what type of client we need...
				this->_editModus.GetString(stringMode, this->_editModus.GetLength() + 1);

				if (strstr(stringMode, "SOAP"))
				{
					// Create new SOAP client
					SpaSeClient = new CSOAPClient(CSOAPClient::RequestMode::SOAP);
					SpaSeClient->SetLoggingHWND(this->_editLogging.Hwnd());

					// Invoke SOAP request
					this->_editEndpoint.GetString(stringEndPoint, this->_editEndpoint.GetLength()+1);
					this->_editService.GetString(stringService, this->_editService.GetLength()+1);
					this->_editMethod.GetString(stringMethod, this->_editMethod.GetLength()+1);
					SpaSeClient->InvokeRequest(stringEndPoint, "", this->m_szFileText, stringService, stringMethod);
				}
				else
				{
					// Create new POST client
					SpaSeClient = new CSOAPClient(CSOAPClient::RequestMode::POST);
					SpaSeClient->SetLoggingHWND(this->_editLogging.Hwnd());

					// Invoke POST request
					this->_editEndpoint.GetString(stringEndPoint, this->_editEndpoint.GetLength()+1);
					SpaSeClient->InvokeRequest(stringEndPoint, "", this->m_szFileText);
				}

			break;
			}
		case IDC_BUTTON3:
			{
				//OPENFILENAME sfn;
				//char szFileName[MAX_PATH] = "";

				//ZeroMemory(&sfn, sizeof(sfn));

				//sfn.lStructSize = sizeof(sfn);
				//sfn.hwndOwner = hwnd;
				//sfn.lpstrFilter = "SpaSe Files (*.xml, *.awql, *.awml)\0*.xml;*.awql;*.awml\0" 
				//				"XML (*.xml)\0*.xml\0" 
				//				"AWQL (*.awql)\0*.awql\0" 
				//				"AWML (*.aqml)\0*.awml\0" 
				//				"Alle Dateien (*.*)\0*.*\0";
				//sfn.lpstrFile = szFileName;
				//sfn.nMaxFile = MAX_PATH;
				//sfn.lpstrDefExt = "xml";
				//sfn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_ENABLESIZING| OFN_OVERWRITEPROMPT;

				//if(GetSaveFileName(&sfn))
				//{
				//	char Out[MAX_LOADSTRING];
				//	strcpy(Out, szFileName);
				//	strcpy(this->m_szFileName, szFileName);
				//	strcat(Out, " -> \n\n");

				//	// Write out the Result...
				//	fstream file_op(this->m_szFileName,ios::out);
				//	file_op << this->m_szResultText;
				//	file_op.close();
				//}
			}
		case IDC_BUTTON4:
			{
				// Init local vars
				char stringEndPoint[512] = "";
				char stringService[512] = "";
				char stringMethod[512] = "";
				char stringMode[5] = "";

				// The request object
				CSOAPClient* SpaSeClient;

				// Clear the Tree-View
				this->_tree.Reset();

				// Check what type of client we need...
				this->_editModus.GetString(stringMode, this->_editModus.GetLength() + 1);

				if (strstr(stringMode, "SOAP"))
				{
					// Create new SOAP client
					SpaSeClient = new CSOAPClient(CSOAPClient::RequestMode::SOAP);

					// Invoke SOAP request
					this->_editEndpoint.GetString(stringEndPoint, this->_editEndpoint.GetLength()+1);
					this->_editService.GetString(stringService, this->_editService.GetLength()+1);
					this->_editMethod.GetString(stringMethod, this->_editMethod.GetLength()+1);
					SpaSeClient->InvokeRequest(stringEndPoint, "", this->m_szFileText, stringService, stringMethod);
				}
				else
				{
					// Create new POST client
					SpaSeClient = new CSOAPClient(CSOAPClient::RequestMode::POST);

					// Invoke POST request
					this->_editEndpoint.GetString(stringEndPoint, this->_editEndpoint.GetLength()+1);
					SpaSeClient->InvokeRequest(stringEndPoint, "", this->m_szFileText);
				}
			}
	}
}