#include "StdAfx.h"
#include ".\soapclient.h"

#include <fstream>

CSOAPClient::CSOAPClient(RequestMode Mode)
{
	this->m_Mode = Mode;
	this->m_pConnection = NULL;

	if (this->m_Mode == CSOAPClient::RequestMode::POST)
	{
		this->m_pConnection = new CConnection(CConnection::HTTP_Mode::HTTP_POST);
	}
}

CSOAPClient::~CSOAPClient(void)
{
}

char* CSOAPClient::InvokeRequest(const char* endpoint, const char* filepath, const char* arg, const char* service, const char* method)
{
	char* RetVal = "";

	switch(this->m_Mode)
	{
	case CSOAPClient::RequestMode::POST:
		RetVal = this->SendPOSTRequest(endpoint, filepath, arg);

		break;
	}

	return RetVal;
}

char* CSOAPClient::SendPOSTRequest(const char* endpoint, const char* filepath, const char* arg)
{
	// Set the necessary values to connection object
	this->m_pConnection->SetHostAdress((char*) endpoint);
	this->m_pConnection->SetFilePath((char*) filepath);
	this->m_pConnection->SetArg((char*) arg);

	// Perform the configured action
	this->m_pConnection->PerformAction();

	return "";
}

void CSOAPClient::SetLoggingHWND(HWND hWnd)
{
	this->m_pConnection->SetLoggingHWND(hWnd);
}

char* CSOAPClient::GetResult()
{
	return this->m_stringResult;
}

CSOAPClient::RequestMode CSOAPClient::GetMode(void)
{
	return this->m_Mode;
}
