#pragma once

#include <ctype.h>

#include "Connection.h"

class CSOAPClient
{
public:
	// Public enumerator
	enum RequestMode
	{
		SOAP = 1,
		POST = 2
	};

	// Constructors & Destructors
	CSOAPClient(RequestMode Mode = POST);
	~CSOAPClient(void);

	// Request Methods
	char* InvokeRequest(const char* endpoint = "", const char* filepath = "", const char* arg = "", const char* service = "", const char* method = "");
	//char* SendSOAPRequest(const char* endpoint, const char* arg, const char* service, const char* method);//, Vector params)
	char* SendPOSTRequest(const char* endpoint, const char* filepath, const char* arg);

	// Other Methods
	void SetLoggingHWND(HWND hWnd);

	// Getter Methods
	char* GetResult(void);
	RequestMode GetMode(void);

protected:
	//Call* m_pCall;
	CConnection* m_pConnection;
	char m_stringResult[65535];
	RequestMode m_Mode;
};
